/*
 * CommunityView.java
 *
 * Created on 25 de agosto de 2004, 04:03 PM
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.Community;
import com.fenalco.entities.StoreList;
import com.fenalco.entities.User;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.StoreListViewSupplier;

/**
 * 
 * @author Juan Ernesto Peña K.
 * @version
 */
public class CommunityView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa la peticiones para los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este servlet recibe en el request un id que identifica a una comunidad
	 * "communityId" -Crea un objeto de tipo Community con el id que se recibió
	 * -Manda el objeto en el response -Redirecciona a comunidad.jsp
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;

		String url;
		String message;

		//Validación de sesión
	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
	
			}
			else
			{
	
				int shopKeeperId;
				if( request.getParameter("shopKeeperId") == null )
				{
					shopKeeperId = -1;
				}
				else
				{
					shopKeeperId = new Integer(request.getParameter("shopKeeperId"))
							.intValue();
				}
	
				User supplier = (User) request.getAttribute("user");
				Community community = new Community(new Integer(request
						.getParameter("key")).intValue());
				StoreList storeList = new StoreList();
				storeList.getCommunityStores(shopKeeperId, community.getId());
				StoreListViewSupplier view = new StoreListViewSupplier(storeList);
	
				if( community == null || view == null )
				{
					//Fallo en la carga de los datos de la comunidad
					url = "/proveedor/comunidad.jsp";
					//message = "Error al cargar la comunidad";
					message = MessageBuilder.buildMessage(9);
				}
				else
				{
					//Todo OK
					url = "/proveedor/comunidad.jsp";
					//message = "La carga de los datos de la comunidad finalizó
					// correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					request.setAttribute("community", community);
					request.setAttribute("shopKeeper", new Integer(shopKeeperId));
					request.setAttribute("view", view);
				}
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		//request.setAttribute("shopKeeperList",DataAccess.getShopKeepers());
		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);

	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición del servlet
	 * @param response
	 *            Repuesta del servlet
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Retorna una breve descripción del servlet.
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}